<script setup>
import { ref } from 'vue';

import ContributorsTable from '~/common/components/ContributorsTable.vue';
import FilterCard from '~/common/components/FilterCard.vue';
import RoutePagination from '~/common/components/RoutePagination.vue';
import ThemedOverlay from '~/common/components/ThemedOverlay.vue';
import { buildUrl } from '~/common/UrlUtils';

const leaders = ref([]);
const busy = ref(true);
const filterData = ref({
  search: '',
  fromDate: '',
  toDate: '',
  communityOnly: true,
  currentPage: 1,
});
const pageData = ref({
  perPage: 50,
  totalRows: 0,
});

const fetchData = async () => {
  busy.value = true;
  const query = {
    from_date: filterData.value.fromDate,
    to_date: filterData.value.toDate,
    community_only: filterData.value.communityOnly,
    page: filterData.value.currentPage,
  };
  const search = filterData.value.search;
  if (search.length > 0) query.search = search;
  const url = buildUrl('/api/v1/leaderboard', { query });

  const response = await fetch(url);
  const { records, metadata } = await response.json();
  leaders.value = records;
  pageData.value = {
    perPage: metadata.per_page,
    totalRows: metadata.total_count,
  };

  busy.value = false;
};
</script>

<template>
  <FilterCard
    v-model="filterData"
    show-community-only
    show-search
    @filter="fetchData"
  />

  <ThemedOverlay :show="busy">
    <ContributorsTable
      :contributors="leaders"
      :filter-data="filterData"
    />
    <RoutePagination
      v-model="filterData.currentPage"
      :total-rows="pageData.totalRows"
      :per-page="pageData.perPage"
    />
  </ThemedOverlay>
</template>
